select
    an.numero,
    (select count(*) from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio <= lac.dtinicio) as lactacoes,
    lac.dtinicio as data_inicio,
    lac.dtfim as data_fim,
    (case when (lacant.cdlactacao is not null) then (lac.dtinicio - lacant.dtfim) else null end) as dias_seco,
    (case when (lac.dtfim is not null) then (lac.dtfim - lac.dtinicio) else null end) as duracao,
    (case when (lac.dtfim is not null) then
        (select producaototal from sp_calculaproducaototal(lac.cdlactacao,lac.dtfim)) else null end) as producao_total,
    P1.PRODUCAO305 AS PRODUCAO_305,
    (select max(pesototal) from leite re where re.cdlactacao = lac.cdlactacao) as pico_producao,
    (select first 1 re.dtleite from leite re where re.cdanimal = an.cdanimal and re.dtleite > lac.dtinicio and
        re.dtleite < (coalesce(lac.dtfim, current_date)) and re.pesototal =
        (select max(pesototal) from leite re where re.cdlactacao = lac.cdlactacao) order by re.dtleite) as data_pico,
    ((select first 1 re.dtleite from leite re where re.cdanimal = an.cdanimal and re.dtleite > lac.dtinicio and
        re.dtleite < (coalesce(lac.dtfim, current_date)) and re.pesototal =
        (select max(pesototal) from leite re where re.cdlactacao = lac.cdlactacao) order by re.dtleite) -
        dtinicio) as dias_pico,
    pai.numero as numero_pai,
    pai.nome as nome_pai,
    mae.numero as numero_mae,
    mae.nome as nome_mae
from
    animal an
    join lactacao lac on lac.cdanimal = an.cdanimal
    left join animal pai on pai.cdanimal = an.cdpai
    left join animal mae on mae.cdanimal = an.cdmae
    left join lactacao lacant on lacant.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = lac.cdanimal and re.dtinicio < lac.dtinicio order by re.dtinicio desc)
    LEFT JOIN SP_PRODUCAO305(LAC.CDLACTACAO) P1 ON 1 = 1
where

LAC.DTFIM BETWEEN '2016-01-01' AND '2017-03-31'

order by
    an.numero, lac.dtinicio